;##########################################################################
.386
.model flat, stdcall
option casemap:none
title TopText
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
include C:\masm32\include\gdi32.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\gdi32.lib
;##########################################################################
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
;##########################################################################
;##########################################################################
	hExStyle	equ	WS_EX_TOPMOST
	hStyle		equ	WS_THICKFRAME OR WS_SYSMENU OR WS_MINIMIZEBOX
	dwWidth		equ	400
	dwHeight	equ	300

	CurDate		TEXTEQU	<">, @Date, <">
	CurTime		TEXTEQU	<">, @Time, <">
	CurFileName	TEXTEQU	<">, @FileCur, <">
;##########################################################################
WndProc		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
FreeRes		PROTO
;##########################################################################
.const
	szAppTitle	db		"TopText", 0
	szAppClass	db		"TOPTEXT32", 0
	szMsgAbout	db		"TopText", 13, 10
			db		"Built on ", CurDate, " ", CurTime, 13, 10
			db		"Version 1.0", 13, 10
			db		"Coded by comrade <comrade2k@hotmail.com>", 13, 10
			db		"Web: http://www.comrade64.com/", 13, 10
			db		"http://comrade.ownz.com/", 13, 10
			db		"http://comrade.win32asm.com/", 13, 10
			db		"http://comrade64.cjb.net/", 13, 10
			db		"IRC: #asm, #coders, #win32asm on EFnet", 0
	szMenuAbout	db		"&About TopText...", 0
	szText		db		"comrade"
	fnt		LOGFONT		<64, 0, 0, 0, FW_BOLD, 0, 0, 0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH OR FF_DONTCARE, "Tahoma">
;##########################################################################
.data
;##########################################################################
.data?
	hRegion		dd		?
	hFont		dd		?

	msg		MSG		<>
	data_start	equ		$
	wc		WNDCLASSEX	<>
	mbp		MSGBOXPARAMS	<>
	ps		PAINTSTRUCT	<>
	rc		RECT		<>
	rcRegion	RECT		<>
	data_size	equ		$ - data_start
;##########################################################################
.code
start:	push	edi
	xor	eax, eax
	mov	ecx, data_size shr 2
	mov	edi, data_start
	rep	stosd
	IF data_size AND 3
		mov	ecx, data_size and 3
		rep	stosb
	ENDIF
	pop	edi
	invoke	GetModuleHandle, eax
	xor	ecx, ecx
	mov	[wc.hInstance], eax
	mov	[mbp.hInstance], eax
	or	[wc.cbSize], sizeof wc
	or	[wc.style], CS_HREDRAW OR CS_VREDRAW
	or	[wc.lpfnWndProc], OFFSET WndProc
	or	[wc.lpszClassName], OFFSET szAppClass
	push	ecx
	push	eax
	push	ecx
	push	ecx
	invoke	LoadIcon, eax, 2
	mov	[wc.hIcon], eax
	invoke	LoadImage, [wc.hInstance], 2, IMAGE_ICON, 16, 16, 0
	mov	[wc.hIconSm], eax
	invoke	LoadCursor, 0, IDC_ARROW
	mov	[wc.hCursor], eax
	invoke	GetStockObject, BLACK_BRUSH
	mov	[wc.hbrBackground], eax
	invoke	RegisterClassEx, ADDR wc

	push	dwHeight
	push	dwWidth
	invoke	GetSystemMetrics, SM_CYSCREEN
	sar	eax, 1
	sub	eax, dwHeight/2
	push	eax
	invoke	GetSystemMetrics, SM_CXSCREEN
	sar	eax, 1
	sub	eax, dwWidth/2
	push	eax
	push	hStyle
	push	OFFSET szAppTitle
	push	OFFSET szAppClass
	push	hExStyle

	call	CreateWindowEx	;invoke	CreateWindowEx, hExStyle, ADDR szAppClass, ADDR szAppTitle, hStyle, ecx, eax, dwWidth, dwHeight, 0, [hMenu], [wc.hInstance], 0
	mov	[mbp.hwndOwner], eax
	push	eax
	invoke	ShowWindow, eax, SW_SHOW
	call	UpdateWindow

@@mloop:xor	eax, eax
	invoke	GetMessage, ADDR msg, eax, eax, eax
	test	eax, eax
	jz	@@mend
	mov	eax, OFFSET msg
	push	eax
	invoke	TranslateMessage, eax
	call	DispatchMessage
	jmp	@@mloop
@@mend:	invoke	ExitProcess, [msg.wParam]
;#########################################################################
WndProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	.if [uMsg]==WM_CREATE
		invoke	GetSystemMenu, [hWnd], 0
		push	OFFSET szMenuAbout
		push	10
		push	MFT_STRING
		push	eax
		invoke	AppendMenu, eax, MFT_SEPARATOR, 0, 0
		call	AppendMenu
		invoke	CreateFontIndirect, ADDR fnt
		mov	[hFont], eax
		invoke	SendMessage, [hWnd], WM_SETFONT, eax, 0
	.elseif [uMsg]==WM_SIZE
		movsx	eax, word ptr [lParam+00h]
		movsx	ecx, word ptr [lParam+02h]
		mov	[rc.right], eax
		mov	[rc.bottom], ecx
	.elseif [uMsg]==WM_PAINT
		invoke	BeginPaint, [hWnd], ADDR ps
		invoke	SelectObject, [ps.hdc], [hFont]
		invoke	BeginPath, [ps.hdc]
		invoke	DrawText, [ps.hdc], ADDR szText, sizeof szText, ADDR rc, DT_SINGLELINE OR DT_CENTER OR DT_VCENTER
		invoke	EndPath, [ps.hdc]
		invoke	DeleteObject, [hRegion]
		invoke	PathToRegion, [ps.hdc]
		mov	[hRegion], eax
		invoke	EndPaint, [hWnd], ADDR ps
		invoke	GetRgnBox, [hRegion], ADDR rcRegion
		invoke	CreateRectRgnIndirect, ADDR rcRegion
		push	eax
		invoke	CombineRgn, [hRegion], [hRegion], eax, RGN_XOR
		call	DeleteObject
		invoke	SetWindowRgn, [hWnd], [hRegion], 1
	.elseif [uMsg]==WM_SYSCOMMAND && [wParam]==10
		mov	[mbp.cbSize], sizeof mbp
		mov	[mbp.lpszText], OFFSET szMsgAbout
		mov	[mbp.lpszCaption], OFFSET szAppTitle
		mov	[mbp.dwStyle], MB_OK OR MB_APPLMODAL OR MB_USERICON
		mov	[mbp.lpszIcon], 2
		invoke	MessageBoxIndirect, ADDR mbp
	.elseif [uMsg]==WM_CLOSE
		call	FreeRes
	.elseif [uMsg]==WM_DESTROY
		invoke	PostQuitMessage, 0
		xor	eax, eax
		ret
	.endif
	pop	ebp
	jmp	DefWindowProc
WndProc endp
;##########################################################################
FreeRes proc
	invoke	DestroyIcon, [wc.hIcon]
	invoke	DestroyIcon, [wc.hIconSm]
	invoke	DeleteObject, [hFont]
	invoke	DeleteObject, [hRegion]
	ret
FreeRes endp
;##########################################################################
;##########################################################################
;##########################################################################
end start